[SRU] uses uninitialized memory with MUMPS >= 5.1.0

Bug #1833037 reported by Graham Inggs on 2019-06-17
8
This bug affects 1 person
Affects Status Importance Assigned to Milestone
coinor-ipopt (Debian)
Fix Released
Unknown
coinor-ipopt (Ubuntu)
Undecided
Unassigned
Bionic
Undecided
Unassigned
Cosmic
Undecided
Unassigned
Disco
Undecided
Unassigned

Bug Description

[Impact]
IPOPT uses uninitialized memory due to a change in the MUMPS API.
First reported in idyntree upstream:
https://github.com/robotology/idyntree/issues/456
Running ipopt_example in valgrind gives the following output:

==8203== Conditional jump or move depends on uninitialised value(s)
==8203== at 0x5C41E26: dmumps_ (in /usr/lib/x86_64-linux-gnu/libdmumps_seq-5.1.2.so)
==8203== by 0x5C4744D: dmumps_f77_ (in /usr/lib/x86_64-linux-gnu/libdmumps_seq-5.1.2.so)
==8203== by 0x5C3FF52: dmumps_c (in /usr/lib/x86_64-linux-gnu/libdmumps_seq-5.1.2.so)
==8203== by 0x4C34336:
Ipopt::MumpsSolverInterface::MumpsSolverInterface() (in /usr/lib/libipopt.so.1.9.9)
==8203== by 0x4B64B7A:
Ipopt::AlgorithmBuilder::BuildBasicAlgorithm(Ipopt::Journalist const&, Ipopt::OptionsList const&, std::__cxx11::basic_string<char, std::char_traits<char>, std::allocator<char> > const&) (in /usr/lib/libipopt.so.1.9.9)
==8203== by 0x4B26CB5:
Ipopt::IpoptApplication::OptimizeNLP(Ipopt::SmartPtr<Ipopt::NLP> const&, Ipopt::SmartPtr<Ipopt::AlgorithmBuilder>&) (in /usr/lib/libipopt.so.1.9.9)
==8203== by 0x4B1E4D8:
Ipopt::IpoptApplication::OptimizeNLP(Ipopt::SmartPtr<Ipopt::NLP> const&) (in /usr/lib/libipopt.so.1.9.9)
==8203== by 0x4B1E6A9:
Ipopt::IpoptApplication::OptimizeTNLP(Ipopt::SmartPtr<Ipopt::TNLP> const&) (in /usr/lib/libipopt.so.1.9.9)
==8203== by 0x10B58F: main (in /home/graham/debian-packages-ssd/coinor-ipopt/ipopt-cmake-demo/build/ipopt_example)
...
==8203== ERROR SUMMARY: 1 errors from 1 contexts (suppressed: 0 from 0)

[Test Case]
sudo apt install cmake valgrind build-essential coinor-libipopt-dev
git clone https://github.com/traversaro/ipopt-cmake-demo
cd ipopt-cmake-demo
mkdir build
cd build
cmake ..
make
valgrind ./ipopt_example

valgrind should report 0 errors:
==8300== ERROR SUMMARY: 0 errors from 0 contexts (suppressed: 0 from 0)

[Regression Potential]
Upstream committed the fix on 2018-06-27
https://github.com/coin-or/Ipopt/commit/4c36f888f1e8a609975f0bee60fe04958024236c
and it was included in 3.12.11 released on 2018-09-16.
Reverse build dependencies are freefem++ and kido

Graham Inggs (ginggs) on 2019-06-17
Changed in coinor-ipopt (Ubuntu):
status: New → Fix Released
Graham Inggs (ginggs) on 2019-06-17
description: updated
Changed in coinor-ipopt (Debian):
status: Unknown → Fix Released
Graham Inggs (ginggs) on 2019-06-18
Changed in coinor-ipopt (Ubuntu Bionic):
status: New → In Progress
Changed in coinor-ipopt (Ubuntu Cosmic):
status: New → In Progress
Changed in coinor-ipopt (Ubuntu Disco):
status: New → In Progress

Hello Graham, or anyone else affected,

Accepted coinor-ipopt into disco-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/coinor-ipopt/3.11.9-2.1ubuntu0.19.04.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-disco to verification-done-disco. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-disco. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Changed in coinor-ipopt (Ubuntu Disco):
status: In Progress → Fix Committed
tags: added: verification-needed verification-needed-disco
Changed in coinor-ipopt (Ubuntu Cosmic):
status: In Progress → Fix Committed
tags: added: verification-needed-cosmic
Brian Murray (brian-murray) wrote :

Hello Graham, or anyone else affected,

Accepted coinor-ipopt into cosmic-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/coinor-ipopt/3.11.9-2.1ubuntu0.18.10.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-cosmic to verification-done-cosmic. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-cosmic. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Changed in coinor-ipopt (Ubuntu Bionic):
status: In Progress → Fix Committed
tags: added: verification-needed-bionic
Brian Murray (brian-murray) wrote :

Hello Graham, or anyone else affected,

Accepted coinor-ipopt into bionic-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/coinor-ipopt/3.11.9-2.1ubuntu0.18.04.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-bionic to verification-done-bionic. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-bionic. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Silvio Traversaro (pegua1) wrote :

I tested the version of the package 3.11.9-2.1ubuntu0.18.04.1 from bionic-proposed, and indeed it fixes the bug for me. Thanks.

tags: added: verification-done-bionic
removed: verification-needed-bionic
Graham Inggs (ginggs) wrote :

I've tested the updated packages in disco and cosmic. It wasn't necessary to recompile ipopt_example; upgrading the library was enough.

tags: added: verification-done verification-done-cosmic verification-done-disco
removed: verification-needed verification-needed-cosmic verification-needed-disco
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package coinor-ipopt - 3.11.9-2.1ubuntu0.19.04.1

---------------
coinor-ipopt (3.11.9-2.1ubuntu0.19.04.1) disco; urgency=medium

  * Backport fix from 3.11.9-2.2 in Eoan (LP: #1833037)
    - Avoid use of uninitialized memory (Closes: #930577)

 -- Graham Inggs <email address hidden> Tue, 18 Jun 2019 10:47:03 +0000

Changed in coinor-ipopt (Ubuntu Disco):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for coinor-ipopt has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package coinor-ipopt - 3.11.9-2.1ubuntu0.18.10.1

---------------
coinor-ipopt (3.11.9-2.1ubuntu0.18.10.1) cosmic; urgency=medium

  * Backport fix from 3.11.9-2.2 in Eoan (LP: #1833037)
    - Avoid use of uninitialized memory (Closes: #930577)

 -- Graham Inggs <email address hidden> Tue, 18 Jun 2019 11:31:52 +0000

Changed in coinor-ipopt (Ubuntu Cosmic):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package coinor-ipopt - 3.11.9-2.1ubuntu0.18.04.1

---------------
coinor-ipopt (3.11.9-2.1ubuntu0.18.04.1) bionic; urgency=medium

  * Backport fix from 3.11.9-2.2 in Eoan (LP: #1833037)
    - Avoid use of uninitialized memory (Closes: #930577)

 -- Graham Inggs <email address hidden> Tue, 18 Jun 2019 11:36:02 +0000

Changed in coinor-ipopt (Ubuntu Bionic):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.